FORMAT: 1A

# need-matchmaking-backend

need-matchmaking-backend is beckend api service for need-matchmaking 

# Group Beneficiary

## Beneficiary [/beneficiary]

### Create a New Beneficiary [POST]

Create a new beneficiary from information given in payload.

+ Request (application/json)
    + Headers
        
            Authorization: token

    + Attributes (BeneficiaryPayload)

+ Response 201 (application/json)
    + Attributes (BeneficiaryDetail)

+ Response 404 (application/json)

+ Response 500 (application/json)

## Beneficiary list [/beneficiary{?name,category,receiver_name,location.name,location.country,location.city,location.address,is_active,limit,page,sort}]

+ Parameters
    + name           (string) - beneficiary name
    + category       (string) - beneficiary category
    + receiver_name  (string) - beneficiary receiver name
    + `location.name`   (string) - beneficiary location name
    + `location.country`(string) - beneficiary location country
    + `location.city`   (string) - beneficiary location city
    + `location.address`(string) - beneficiary location address
    + is_active      (boolean) - beneficiary status active or not
    + limit          (integer) - beneficiary rows per-page
    + page           (integer) - beneficiary page default `1`
    + sort : `-name` (string) - beneficiary sort field, `-` for descending
    
### Get list Beneficiary [GET]

Get list beneficiary from information given in payload.

+ Request
    + Headers
        
            Authorization: token

+ Response 200 (application/json)
    + Attributes (Beneficiaries)

+ Response 500 (application/json)

## Beneficiary detail [/beneficiary/{id}]

+ Parameters
    + id (required, string) - beneficiary id

### Get Detail Beneficiary [GET]

Get detail beneficiary from id.

+ Request
    + Headers
        
            Authorization: token

+ Response 200 (application/json)
    + Attributes (BeneficiaryDetail)

+ Response 404 (application/json)

+ Response 500 (application/json)

### Update Beneficiary Detail [PUT]

Update detail beneficiary by id.

+ Request
    + Headers
        
            x-api-key: api_key

    + Attributes (BeneficiaryPayload)

+ Response 200 (application/json)
    + Attributes (BeneficiaryDetail)

+ Response 404 (application/json)

+ Response 500 (application/json)

# Group Category

## Category list [/category]

### Get list category [GET]
Get list category.

+ Request
    + Headers
        
            Authorization: token

+ Response 200 (application/json)
    + Attributes (Categories)

+ Response 404 (application/json)

+ Response 500 (application/json)

# Group Contributor

## Contributor [/contributor]

### Create a New Contributor [POST]

Create a new contributor from information given in payload.

+ Request (application/json)
    + Headers
        
            Authorization: token

    + Attributes (ContributorPayload)

+ Response 201 (application/json)
    + Attributes (ContributorDetail)

+ Response 404 (application/json)

+ Response 500 (application/json)

## Contributor list [/contributor{?name,category,provider_name,location.name,location.country,location.city,location.address,is_active,limit,page,sort}]

+ Parameters
    + name           (string) - contributor aid name
    + category       (string) - contributor aid category
    + provider_name  (string) - contributor aid provider name
    + `location.name`   (string) - contributor aid location name
    + `location.country`   (string) - contributor aid location country
    + `location.city`   (string) - contributor aid location city
    + `location.address`(string) - contributor aid location address
    + is_active      (boolean) - contributor status active or not
    + limit          (integer) - contributor rows per-page
    + page           (integer) - contributor page default `1`
    + sort : `-name` (string) - contributor sort field, `-` for descending
    
### Get list Contributor [GET]

Get list contributor from information given in payload.

+ Request
    + Headers
        
            Authorization: token

+ Response 200 (application/json)
    + Attributes (Contributors)

+ Response 500 (application/json)

## Contributor detail [/contributor/{id}]

+ Parameters
    + id (required, string) - contributor id

### Get Detail Contributor [GET]

Get detail contributor from id.

+ Request
    + Headers
        
            Authorization: token

+ Response 200 (application/json)
    + Attributes (ContributorDetail)

+ Response 404 (application/json)

+ Response 500 (application/json)

# Group User

## User [/user/register]

### Register User [POST]

Register new user.

+ Request (application/json)
    + Headers
        
            x-api-key: api_key

    + Attributes (RegisterPayload)

+ Response 201 (application/json)

+ Response 404 (application/json)

+ Response 500 (application/json)

# Group Auth

## Login [/login]

### Login User [POST]

Login

+ Request (application/json)
    + Headers
        
            x-api-key: api_key

    + Attributes (LoginPayload)

+ Response 201 (application/json)
    + Attributes (LoginResponse)

+ Response 404 (application/json)

+ Response 500 (application/json)

## Refresh Token [/refresh_token]

### Refresh Token [POST]

Refresh token

+ Request (application/json)
    + Headers
        
            x-api-key: api_key

    + Attributes (RefreshTokenPayload)

+ Response 201 (application/json)
    + Attributes (LoginResponse)

+ Response 404 (application/json)

+ Response 500 (application/json)

# Data Structures

## integer (number)

## timestamp (string)

## BeneficiaryPayload (object)
+ name          : `masker untuk puskesmas` (string, required) - beneficiary name
+ category      : `masker` (string, required) - beneficiary category
+ provider_name : `dr wardoyo` (string, required) - aid provider name
+ amount        : 100 (integer, required) - beneficiary amount need
+ receiver_name : `dr wardoyo` (string, required) - beneficiary receiver name
+ phone         : `081234567890` (string, required) - phone number
+ is_whatsapp_available : false (boolean) - true if whatsapp available
+ note          : `puskesmas hanya buka di jam kerja` (string) - note
+ item_details (array[ItemDetail])
+ location (Location)

## BeneficiaryDetail (object)
+ _id            : `4a618aaf-56bf-4b5b-bced-a8c2c6467151` (string) - generated id
+ name          : `masker untuk puskesmas` (string, required) - beneficiary name
+ category      : `masker` (string, required) - beneficiary category
+ provider_name : `dr wardoyo` (string, required) - aid provider name
+ amount        : 100 (integer, required) - beneficiary amount need
+ receiver_name : `dr wardoyo` (string, required) - beneficiary receiver name
+ phone         : `081234567890` (string, required) - phone number
+ is_whatsapp_available : false (boolean) - true if whatsapp available
+ note          : `puskesmas hanya buka di jam kerja` (string) - note
+ is_active     : true (boolean) - beneficiary status
+ created_at    : `2020-04-01T13:49:05.805582Z` (timestamp) - beneficiary created time
+ updated_at    : `` (timestamp) - beneficiary updated time
+ item_details (array[ItemDetail])
+ location (LocationResult)
+ distance (Distance)

## Beneficiaries (object)
+ data (array[BeneficiaryDetail])
+ limit : 10 (integer, required) - limit of data
+ page  : 1 (integer, required) - page of data
+ total : 1 (integer, required) - total data

## CategoryDetail (object)
+ _id           : `MASKER_BEDAH` (string, required) - category id
+ name          : `masker standard bedah` (string, required) - category name
+ description   : `masker` (string) - description

## Categories (object)
+ data (array[CategoryDetail])
+ total : 1 (integer, required) - total data

## ItemDetail (object)
+ name : `masker bedah` (string) - name of item detail
+ quantity : 10 (integer) - quantity of item detail

## Location (object)
+ name: `Slipi Petamburan` (string) - name of location
+ country: `Indonesia` (string) - country of location
+ city: `Jakarta Pusat` (string) - city of location
+ address: `Gelora, Tanahabang, Central Jakarta City, Jakarta, Indonesia` (string) - address of location
+ longitude: 106.800685 (number) - longitude of location
+ latitude: 6.204318 (number) - latitude of location

## LocationResult (object)
+ name: `Slipi Petamburan` (string) - name of location
+ country: `Indonesia` (string) - country of location
+ city: `Jakarta Pusat` (string) - city of location
+ address: `Jl. Pejompongan Dalam 1-29, RT.4/RW.5, Bend. Hilir, Kecamatan Tanah Abang, Daerah Khusus Ibukota Jakarta 10210` (string) - address of location
+ longitude: 106.800685 (number) - longitude of location
+ latitude: 6.204318 (number) - latitude of location

## Distance (object)
+ length: 1.1809069286636493 (number) - length of location
+ unit: `km` (string) - unit of distance, km and m

## ContributorPayload (object)
+ name          : `masker untuk puskesmas` (string, required) - aid name
+ category      : `masker` (string, required) - aid category
+ amount        : 100 (integer, required) - aid amount need
+ provider_name : `dr wardoyo` (string, required) - aid provider name
+ phone         : `081234567890` (string, required) - phone number
+ is_phone_number_hidden : false (boolean) - true if phone number is hidden
+ is_whatsapp_available : false (boolean) - true if whatsapp available
+ note          : `puskesmas hanya buka di jam kerja` (string) - note
+ item_details (array[ItemDetail])
+ location (Location)

## ContributorDetail (object)
+ _id            : `4a618aaf-56bf-4b5b-bced-a8c2c6467151` (string) - generated id
+ name          : `masker untuk puskesmas` (string, required) - aid name
+ category      : `masker` (string, required) - aid category
+ amount        : 100 (integer, required) - aid amount need
+ provider_name : `dr wardoyo` (string, required) - aid provider name
+ phone         : `081234567890` (string, required) - phone number
+ is_phone_number_hidden : false (boolean) - true if phone number is hidden
+ is_whatsapp_available : false (boolean) - true if whatsapp available
+ note          : `puskesmas hanya buka di jam kerja` (string) - note
+ is_active     : true (boolean) - aid status
+ created_at    : `2020-04-01T13:49:05.805582Z` (timestamp) - aid created time
+ updated_at    : `` (timestamp) - aid updated time
+ item_details (array[ItemDetail])
+ location (LocationResult)
+ distance (Distance)

## Contributors (object)
+ data (array[ContributorDetail])
+ limit : 10 (integer, required) - limit of data
+ page  : 1 (integer, required) - page of data
+ total : 1 (integer, required) - total data

## User (object)
+ _id            : `4a618aaf-56bf-4b5b-bced-a8c2c6467151` (string) - generated id
+ user_name      : `foo` (string, required) - username
+ password       : `password` (string, required) - password
+ phone_number   : `62857152231` (string, required) - phone_number
+ roles          : `roles` (string, required) - roles
+ created_at    : `2020-04-01T13:49:05.805582Z` (timestamp) - aid created time
+ updated_at    : `` (timestamp) - aid updated time

## RegisterPayload (object)
+ user_name      : `foo` (string, required) - username
+ password       : `password` (string, required) - password
+ `phone_number`   : `62857152231` (string, required) - phone_number
+ roles          : `roles` (string, required) - roles

## LoginPayload (object)
+ user_name      : `foo` (string, required) - username
+ password       : `password` (string, required) - password

## LoginResponse (object)
+ user_name      : `foo` (string) - username
+ token          : `your token` (string) - token
+ refresh_token  : `refresh token` (string) - token

## RefreshTokenPayload (object)
+ token          : `your token` (string, required) - token
+ refresh_token  : `refresh token` (string, required) - token
